<template lang="pug">

.input(
  :class="type === 'editor' ? 'editor-input': ''")

  label.input__label(:for="name" :class="classLabel()" ) {{ label }}
    span.input__label-required(v-if="required") &nbsp;*

  el-input(
    :id="name"
    v-if="type === 'text' || type === 'password'"
    @keyup.enter.native="submitFunc(formRef)"
    :type="passwordType()"
    :placeholder="placeholder"
    v-model="modelInput"
    :input="rewriteModelAndLabelActive"
    :required="required"
    @focus="labelBlurOff"
    @blur="labelBlur"
    :disabled="disabled")

  .el-input(v-if="type === 'phone'")
    input.el-input__inner(
      :id="name"
      @keyup.enter.native="submitFunc(formRef)"
      type="text"
      :placeholder="placeholder"
      v-model="modelInput"
      :input="rewriteModelAndLabelActive"
      :required="required"
      @focus="labelBlurOff"
      @blur="labelBlur"
      v-mask="'+7 (###) ### ## ##'"
      :disabled="disabled")

  el-input(
    :id="name"
    v-if="type === 'textarea'"
    @keyup.enter.native="submitFunc(formRef)"
    :type="type"
    :placeholder="placeholder"
    v-model="modelInput"
    :input="rewriteModelAndLabelActive"
    :required="required"
    @focus="labelBlurOff"
    @blur="labelBlur"
    :maxlength="maxlength ? maxlength : 9999999999999"
    :autosize="autosize"
    :disabled="disabled")

  el-select(
    :id="name"
    v-if="type === 'select'"
    v-model='modelInput'
    placeholder=''
    @focus="labelBlurOff"
    @blur="labelBlur"
    :change="rewriteModelAndLabelActive"
    :disabled="disabled")
    el-option(
      v-for='item in options'
      :key='item.value'
      :label='item.label'
      :value='item.value')

  el-date-picker(
    :id="name"
    v-if="type === 'datetime'"
    v-model='modelInput'
    format='dd.MM.yyyy, H:mm'
    value-format='timestamp'
    :type='type'
    :placeholder='placeholder'
    :disabled="disabled"
    @focus="labelBlurOff"
    @blur="labelBlur"
    :change="rewriteModelAndLabelActive")

  .quill-editor(
    v-if='type === "editor"'
    v-model='modelInput'
    :change='rewriteModelAndLabelActive'
    v-quill:myquilleditor='editorOption')

  el-input-number(
    :id="name"
    v-if="type === 'sort'"
    @keyup.enter.native="submitFunc(formRef)"
    :placeholder="placeholder"
    v-model="modelInput"
    :input="rewriteModelAndLabelActive"
    :required="required"
    @focus="labelBlurOff"
    @blur="labelBlur"
    :disabled="disabled"
    :step="step"
    controls-position="right"
    :min='1')

  span.input-icon__password-view(
    @click="passwordView = !passwordView"
    v-if="type === 'password'")
    font-awesome-icon(
      :icon="passwordView ? 'eye-slash' : 'eye'"
      size="lg")
  .justify-content-between(style="display: flex; margin-top: 5px")
    span.input__prompt(v-if="prompt" v-html="prompt")
    span(v-if='maxlength') {{ `${modelInput.length}/${maxlength}` }}

</template>

<script>
export default {
  name: 'InputItem',
  props: {
    id: {
      type: [Number, String],
      required: true
    },
    placeholder: {
      type: String,
      required: true
    },
    model: {
      type: [String, Object, Number],
      required: false,
      default: ''
    },
    name: {
      type: String,
      required: true
    },
    label: {
      type: String,
      required: true
    },
    required: {
      type: Boolean,
      required: false,
      default: false
    },
    prompt: {
      type: String,
      required: false,
      default: ''
    },
    type: {
      type: String,
      required: false,
      default: 'text'
    },
    formRef: {
      type: String,
      required: false,
      default: ''
    },
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    autosize: {
      type: [String, Object],
      required: false,
      default: () => {}
    },
    maxlength: {
      type: Number,
      required: false,
      default: null
    },
    options: {
      type: Array,
      required: false,
      default: () => []
    },
    submitFunc: {
      type: Function,
      required: false,
      default: () => console.log('submit')
    },
    step: {
      type: Number,
      required: false,
      default: 1
    },
    uploadPath: {
      type: String,
      required: false,
      default: ''
    },
    imageUploadView: {
      type: Boolean,
      required: false,
      default: () => true
    },
    toolbarConfig: {
      type: Array,
      required: false,
      default: () => [
        ['bold', 'italic', 'underline', 'strike'],
        [{ align: [] }],
        [{ header: [2, 3, 4, 5, 6, false] }],
        ['blockquote', 'link'],
        ['image', 'video'],
        [{ list: 'ordered' }, { list: 'bullet' }],
        [{ indent: '-1' }, { indent: '+1' }],
        [{ color: [] }, { background: [] }],
        ['clean']
      ]
    }
  },
  data() {
    return {
      labelActive: false,
      labelFocus: false,
      editorOption: {
        // some quill options
        modules: {
          toolbar: this.toolbarConfig,
          imageUpload: {
            url: `${this.$store.state.baseURL}/api/v1/img?path=${
              this.uploadPath
            }`,
            method: 'POST',
            name: 'image',
            callbackOK: serverResponse => {
              let newImage = `<img src=${serverResponse.photo}>`;
              this.modelInput = this.modelInput + newImage;
              this.rewriteModel();
              this.$emit('image-upload', serverResponse.photo);
            }
          }
        },
        placeholder: this.placeholder
      },
      modelInput: this.model,
      passwordView: false
    };
  },
  computed: {
    rewriteModelAndLabelActive() {
      return this.rewriteModel();
    }
  },
  mounted() {
    if (!this.model && this.type === 'sort') {
      this.modelInput = 100;
    }
  },
  methods: {
    rewriteModel() {
      this.$emit('input-value', [this.id, this.modelInput, this.name]);
      this.modelInput || this.labelFocus
        ? (this.labelActive = true)
        : (this.labelActive = false);
    },
    labelBlurOff() {
      this.labelFocus = true;
    },
    labelBlur() {
      this.labelFocus = false;
    },
    classLabel() {
      return {
        input__label_active: this.labelActive === true
      };
    },
    passwordType() {
      return this.passwordView ? 'text' : this.type;
    }
  }
};
</script>
